`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/05/19 22:38:27
// Design Name: 
// Module Name: fsm
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module fsm(
    input [8:0]last_change,
    input key_valid,
    input clk,
    input rst_n,
    output reg [8:0]addend,
    output reg [8:0]augend
    );
    reg [1:0]state, next_state;

always@*
  case (state)
    2'b00:
      if (key_valid)
      begin
        next_state = 2'b01;
        addend = last_change;
        augend = 9'h70;
      end
      else
      begin
        next_state = 2'b00;
        addend = addend;
        augend = augend;
      end
    2'b01:
      if (key_valid)
      begin
        next_state = 2'b10;
        addend = last_change;
        augend = 9'h70;
      end
      else
      begin
        next_state = 2'b01;
        addend = addend;
        augend = augend;
      end
    2'b10:
        if (key_valid)
        begin
          next_state = 2'b11;
          addend = addend;
          augend = last_change;
        end
        else
        begin
          next_state = 2'b10;
          addend = addend;
          augend = augend;
        end
    2'b11:
        if (key_valid)
          begin
            next_state = 2'b00;
            addend = addend;
            augend = last_change;
          end
          else
          begin
            next_state = 2'b11;
            addend = addend;
            augend = augend;
          end
    default:
    begin
      next_state = 2'b00;
      addend = 9'h70;
      augend = 9'h70;
    end
  endcase

always@(posedge clk or negedge rst_n)
  if (~rst_n)
    state <= 2'b00;
  else
    state <= next_state;

endmodule
