`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/05/19 23:18:37
// Design Name: 
// Module Name: top
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module top(
    inout PS2_DATA,
    inout PS2_CLK,
    input rst,
    input clk,
    output [3:0]ssd,
    output [7:0]seg
    );
    wire [511:0]key_down;
    wire [8:0]last_change;
    wire key_valid;
    wire [8:0]addend;
    wire [8:0]augend;
    wire [3:0]digit3, digit2, digit1, digit0;
    wire [1:0]ssd_ctl_en;
    wire [3:0]ssd_in;

    KeyboardDecoder U0(
        .key_down(key_down),
        .last_change(last_change),
        .key_valid(key_valid),
        .PS2_DATA(PS2_DATA),
        .PS2_CLK(PS2_CLK),
        .rst(~rst),
        .clk(clk)
    );

    fsm U1(
        .last_change(last_change),
        .key_valid(key_valid),
        .clk(clk),
        .rst_n(rst),
        .addend(addend),
        .augend(augend)
    );

    adder U2(
        .addend(addend),
        .augend(augend),
        .digit3(digit3),
        .digit2(digit2),
        .digit1(digit1),
        .digit0(digit0)
    );

    freq_div U3(
        .clk(clk),
        .rst_n(rst),
        .clk_ctl(ssd_ctl_en)
    );

    scan_ctl U7(
        .ssd_ctl_en(ssd_ctl_en),
        .in3(digit3),
        .in2(digit2),
        .in1(digit1),
        .in0(digit0),
        .ssd_ctl(ssd),
        .ssd_in(ssd_in)
    );

    display U8(
        .in(ssd_in),
        .segs(seg)
    );
endmodule
